Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2191661 - Review Request: python-bsmschema - BIDS Stats Models Schema
Summary: Review Request: python-bsmschema - BIDS Stats Models Schema
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Sandro
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: Trivial
Depends On:
Blocks: fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2023-04-28 17:33 UTC by Ben Beasley
Modified: 2023-06-08 02:02 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2023-05-30 00:19:28 UTC
Type: ---
Embargoed:
gui1ty: fedora-review+


Attachments (Terms of Use)

Description Ben Beasley 2023-04-28 17:33:27 UTC
Spec URL: https://music.fedorapeople.org/python-bsmschema.spec
SRPM URL: https://music.fedorapeople.org/python-bsmschema-0.1.0-1.fc37.src.rpm

Description:

This package contains a Pydantic description of the BIDS Stats Models format,
which can be used as a schema validator or generate JSON schema for independent
validation.

Fedora Account System Username: music

Koji scratch builds:

F39: https://koji.fedoraproject.org/koji/taskinfo?taskID=100493016
F38: https://koji.fedoraproject.org/koji/taskinfo?taskID=100493026
F37: https://koji.fedoraproject.org/koji/taskinfo?taskID=100493027

Comment 1 Sandro 2023-05-28 19:51:05 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Issues
======

[!]: License field in the package spec file matches the actual license.

=> The LICENSE file is for CC-BY-4.0. On GitHub the commit for the LICENSE file states:
"Licensing: CC-BY-4.0 for text, Apache2 for code". I'm not sure what "text" the CC-BY-4.0
license applies to, but the license text for Apache-2.0 appears no to be included.

Upstream probably needs to include the Apache-2.0 text in the LICENSE file as well.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.

Comment 2 Ben Beasley 2023-05-29 20:42:54 UTC
Thank you for the review!

(In reply to Sandro from comment #1)
> 
> [!]: License field in the package spec file matches the actual license.
> 
> => The LICENSE file is for CC-BY-4.0. On GitHub the commit for the LICENSE
> file states:
> "Licensing: CC-BY-4.0 for text, Apache2 for code". I'm not sure what "text"
> the CC-BY-4.0
> license applies to, but the license text for Apache-2.0 appears no to be
> included.
> 
> Upstream probably needs to include the Apache-2.0 text in the LICENSE file
> as well.

So, if you look at https://github.com/bids-standard/stats-models, you’ll see a top-level LICENSE file that is CC-BY-4.0, and a README.md that says:

  This repository is intended to be the authoritative reference
  for the BIDS Stats Models specification. It consists of two parts:

    1.  bsmschema, a Pydantic description of the BIDS Stats Models
        files, which can be used as a schema validator or generate
        JSON schema for independent validation.
    2.  specification, a JupyterBook website that includes more human
        readable introductions and explanations, as well as a
        reference document for bsmschema.

In this context, it seems clear that the “text” that is CC-BY-4.0 is meant to be the contents of specification/, and the “code” is meant to be the contents of bsmschema/.

Since the Python package doesn’t need anything from specification/, I package from the PyPI sdist, which only contains files from bsmschema/. Thus, if you look at the top-level LICENSE file in the source archive, you’ll find it is actually https://github.com/bids-standard/stats-models/blob/0.1.0/bsmschema/LICENSE, which is the Apache-2.0 license text. Since this sdist pretty clearly contains only “code,” I think it’s safe to say that CC-BY-4.0 does not apply. Furthermore, you can verify that pyproject-rpm-macros does handle the license file properly:

$ rpm -qL -p review-python-bsmschema/results/python3-bsmschema-0.1.0-1.fc39.noarch.rpm 
/usr/lib/python3.11/site-packages/bsmschema-0.1.0.dist-info/licenses/LICENSE

...and inspection of its contents confirms it is the Apache-2.0 text.

Let me know if you find any discrepancies in the above.

Comment 3 Sandro 2023-05-29 21:42:41 UTC
Thanks for the detailed explanation. I was being mislead by the split of the repo. What is being published on PyPI and what is contained in the distribution tarball is actually the bsmschema/ directory of the repo. And that indeed contains another LICENSE file with the Apache license text in it.

All good => APPROVED!

Sorry about the noise. ;)

Comment 4 Ben Beasley 2023-05-30 00:09:45 UTC
Thanks! I’m glad you are looking closely at these details. I would rather respond to a concern that turns out to be unfounded than have a careless review.

I am setting the status back to ASSIGNED since this is required when requesting the dist-git repository.

Comment 5 Fedora Admin user for bugzilla script actions 2023-05-30 00:10:15 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/python-bsmschema

Comment 6 Fedora Update System 2023-05-30 00:18:48 UTC
FEDORA-2023-f9fcfdcf26 has been submitted as an update to Fedora 39. https://bodhi.fedoraproject.org/updates/FEDORA-2023-f9fcfdcf26

Comment 7 Fedora Update System 2023-05-30 00:19:28 UTC
FEDORA-2023-f9fcfdcf26 has been pushed to the Fedora 39 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 8 Fedora Update System 2023-05-30 12:58:45 UTC
FEDORA-2023-c19a3c1bc0 has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2023-c19a3c1bc0

Comment 9 Fedora Update System 2023-05-30 16:41:36 UTC
FEDORA-2023-213296bdba has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2023-213296bdba

Comment 10 Fedora Update System 2023-05-31 01:28:49 UTC
FEDORA-2023-213296bdba has been pushed to the Fedora 37 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-213296bdba`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-213296bdba

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 11 Fedora Update System 2023-05-31 02:50:19 UTC
FEDORA-2023-c19a3c1bc0 has been pushed to the Fedora 38 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2023-c19a3c1bc0`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2023-c19a3c1bc0

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2023-06-08 01:59:46 UTC
FEDORA-2023-213296bdba has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 13 Fedora Update System 2023-06-08 02:02:30 UTC
FEDORA-2023-c19a3c1bc0 has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.